| Home | Libraries | People | FAQ | More

##### http::read (3 of 4 overloads)

Read a complete message from a stream.

###### Synopsis

Defined in header `<boost/beast/http/read.hpp>`

    template<
        class SyncReadStream,
        class DynamicBuffer,
        bool isRequest,
        class Body,
        class Allocator>
    std::size_t
    read(
        SyncReadStream& stream,
        DynamicBuffer& buffer,
        message< isRequest, Body, basic_fields< Allocator >>& msg);

###### Description

This function is used to read a complete message from a stream into an instance of `http::message`. The call will block until one of the following conditions is true:

- The entire message is read in.
- An error occurs.

This operation is implemented in terms of one or more calls to the stream's `read_some` function. The implementation may read additional bytes from the stream that lie past the end of the message being read. These additional bytes are stored in the dynamic buffer, which must be preserved for subsequent reads. If the end of file error is received while reading from the stream, then the error returned from this function will be:

- `http::end_of_stream` if no bytes were parsed, or
- `http::partial_message` if any bytes were parsed but the message was incomplete, otherwise:
- A successful result. The next attempt to read will return `http::end_of_stream`

###### Parameters

Name | Description
--- | ---
`stream` | The stream from which the data is to be read. The type must meet the SyncReadStream requirements.
`buffer` | Storage for additional bytes read by the implementation from the stream. This is both an input and an output parameter; on entry, the parser will be presented with any remaining data in the dynamic buffer's readable bytes sequence first. The type must meet the DynamicBuffer requirements.
`msg` | The container in which to store the message contents. This message container should not have previous contents, otherwise the behavior is undefined. The type must be meet the MoveAssignable and MoveConstructible requirements.

###### Return Value

The number of bytes transferred from the stream.

###### Exceptions

Type | Thrown On
--- | ---
`system_error` | Thrown on failure.

###### Remarks

The function returns the total number of bytes transferred from the stream. This may be zero for the case where there is sufficient pre-existing message data in the dynamic buffer. The implementation will call `http::basic_parser::eager` with the value `true` on the parser passed in.

Convenience header `<boost/beast/http.hpp>`